=== debian/changelog ===
libmongocrypt (1.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Update to Standards-Version 4.5.1 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 12 Jan 2021 14:17:05 -0500

libmongocrypt (1.0.4-1) unstable; urgency=medium

  * Initial release (Closes: #968995).

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 25 Aug 2020 11:07:58 -0400
