## libmongocrypt 1.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -238,6 +238,7 @@
    test/test-conveniences.c
    test/test-mongocrypt-buffer.c
    test/test-mongocrypt-cache.c
+   test/test-mongocrypt-cache-oauth.c
    test/test-mongocrypt-ciphertext.c
    test/test-mongocrypt-crypto.c
    test/test-mongocrypt-crypto-hooks.c
@@ -292,4 +293,3 @@
       add_executable (csfle test/util/csfle.c test/util/util.c)
       target_link_libraries (csfle PRIVATE mongocrypt_static)
       target_include_directories (csfle PRIVATE ${CMAKE_BINARY_DIR}/src)
-      target_include_directories (csfle PRIVATE ./src)
