=== debian/changelog ===
libmongocrypt (1.2.2-1) unstable; urgency=medium

  * New upstream release.
  * Update to Standards-Version 4.6.0 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 07 Sep 2021 21:43:35 -0400
