## libmongocrypt 1.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -90,6 +90,7 @@
    src/mongocrypt-opts.c
    src/mongocrypt-status.c
    src/mongocrypt-traverse-util.c
+   src/mongocrypt-util.c
    src/mongocrypt.c
    src/os_win/os_mutex.c
    src/os_win/os_once.c
@@ -248,7 +249,7 @@
 
 
 set (TEST_MONGOCRYPT_SOURCES
-   test/test-conveniences.c
+   test/test-mongocrypt-assert-match-bson.c
    test/test-mongocrypt-buffer.c
    test/test-mongocrypt-cache.c
    test/test-mongocrypt-cache-oauth.c
@@ -264,12 +265,14 @@
    test/test-mongocrypt-key.c
    test/test-mongocrypt-key-broker.c
    test/test-mongocrypt-key-cache.c
+   test/test-mongocrypt-kms-ctx.c
    test/test-mongocrypt-kms-responses.c
    test/test-mongocrypt-local-kms.c
    test/test-mongocrypt-log.c
    test/test-mongocrypt-marking.c
    test/test-mongocrypt-status.c
    test/test-mongocrypt-traverse-util.c
+   test/test-mongocrypt-util.c
    test/test-mongocrypt.c
 )
 
@@ -294,4 +297,3 @@
    target_include_directories (example-state-machine PRIVATE ./src "${CMAKE_CURRENT_SOURCE_DIR}/kms-message/src")
 
    # Define example-state-machine-static
-   add_executable (example-state-machine-static test/example-state-machine.c)
