=== kms-message/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,10 @@
    src/kms_decrypt_request.c
    src/kms_encrypt_request.c
    src/kms_gcp_request.c
+   src/kms_kmip_reader_writer.c
+   src/kms_kmip_request.c
+   src/kms_kmip_response.c
+   src/kms_kmip_response_parser.c
    src/kms_kv_list.c
    src/kms_kv_list.h
    src/kms_message.c
@@ -67,6 +71,16 @@
          "KMS_MESSAGE_ENABLE_CRYPTO_LIBCRYPTO")
 endif()
 
+include (TestBigEndian)
+TEST_BIG_ENDIAN (KMS_BIG_ENDIAN)
+if (KMS_BIG_ENDIAN)
+   message ("Detected byte order: big endian")
+   set (KMS_MESSAGE_DEFINITIONS ${KMS_MESSAGE_DEFINITIONS} "KMS_MESSAGE_BIG_ENDIAN")
+else ()
+   message ("Detected byte order: little endian")
+   set (KMS_MESSAGE_DEFINITIONS ${KMS_MESSAGE_DEFINITIONS} "KMS_MESSAGE_LITTLE_ENDIAN")
+endif ()
+
 add_library (
    kms_message SHARED
    ${KMS_MESSAGE_SOURCES}
@@ -87,6 +101,8 @@
    kms_message_obj OBJECT
    ${KMS_MESSAGE_SOURCES}
 )
+
+target_compile_definitions (kms_message_obj PRIVATE ${KMS_MESSAGE_DEFINITIONS})
 
 if (NOT DISABLE_NATIVE_CRYPTO)
    if (WIN32)
@@ -163,6 +179,9 @@
    src/kms_message/kms_gcp_request.h
    src/kms_message/kms_message.h
    src/kms_message/kms_message_defines.h
+   src/kms_message/kms_kmip_request.h
+   src/kms_message/kms_kmip_response.h
+   src/kms_message/kms_kmip_response_parser.h
    src/kms_message/kms_request.h
    src/kms_message/kms_request_opt.h
    src/kms_message/kms_response.h
@@ -224,8 +243,13 @@
       test_kms_request
       ${KMS_MESSAGE_SOURCES}
       test/test_kms_request.c
+      test/test_kmip_reader_writer.c
+      test/test_kms_util.c
+      test/test_kms_kmip_request.c
+      test/test_kms_kmip_response_parser.c
+      test/test_kms_kmip_response.c
    )
-   target_include_directories(test_kms_request PRIVATE  ${PROJECT_SOURCE_DIR})
+   target_include_directories(test_kms_request PRIVATE ${PROJECT_SOURCE_DIR}/src)
    target_compile_definitions(test_kms_request PRIVATE ${KMS_MESSAGE_DEFINITIONS})
 
    if (WIN32)
@@ -246,16 +270,14 @@
 elseif(DISABLE_NATIVE_CRYPTO)
    message ("test_kms_azure_online target disabled: Not building with native crypto.")
 elseif(ENABLE_ONLINE_TESTS)
-   add_executable(test_kms_azure_online test/test_kms_azure_online.c test/test_kms.c test/test_kms_online_util.c)
+   add_executable(test_kms_azure_online test/test_kms_azure_online.c test/test_kms_util.c test/test_kms_online_util.c)
    target_include_directories(test_kms_azure_online PRIVATE ${PROJECT_SOURCE_DIR}/src)
-   target_include_directories(test_kms_azure_online PRIVATE ${PROJECT_SOURCE_DIR}/src/kms_message)
    target_compile_definitions(test_kms_azure_online PRIVATE ${KMS_MESSAGE_DEFINITIONS})
    target_link_libraries(test_kms_azure_online mongo::mongoc_shared)
    target_link_libraries(test_kms_azure_online kms_message_static)
 
-   add_executable(test_kms_gcp_online test/test_kms_gcp_online.c test/test_kms.c test/test_kms_online_util.c)
+   add_executable(test_kms_gcp_online test/test_kms_gcp_online.c test/test_kms_util.c test/test_kms_online_util.c)
    target_include_directories(test_kms_gcp_online PRIVATE ${PROJECT_SOURCE_DIR}/src)
-   target_include_directories(test_kms_gcp_online PRIVATE ${PROJECT_SOURCE_DIR}/src/kms_message)
    target_compile_definitions(test_kms_gcp_online PRIVATE ${KMS_MESSAGE_DEFINITIONS})
    target_link_libraries(test_kms_gcp_online mongo::mongoc_shared)
    target_link_libraries(test_kms_gcp_online kms_message_static)
