=== debian/changelog ===
libmongocrypt (1.3.0-1ubuntu1) jammy; urgency=medium

  * d/rules: downgrade deprecations errors into warnings to fix the build
    against OpenSSL 3.0

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 07 Dec 2021 15:49:07 +0100

libmongocrypt (1.3.0-1build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Mon, 29 Nov 2021 16:01:17 +0100

libmongocrypt (1.3.0-1) unstable; urgency=medium

  * New upstream release.

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 04 Nov 2021 17:38:47 -0400
