=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: libmongocrypt
 Priority: optional
-Maintainer: Mongo C Driver Team <mongo-c-driver-debian@googlegroups.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Mongo C Driver Team <mongo-c-driver-debian@googlegroups.com>
 Uploaders: Kevin Albertson <kevin.albertson@mongodb.com>,
-           Clyde Bazile <clyde.bazile@mongodb.com>,
-           Samantha Ritter <samantha.ritter@mongodb.com>,
            Roberto C. Sanchez <roberto@connexer.com>
 Build-Depends: debhelper (>= 10),
                cmake,
                libssl-dev,
                pkg-config,
                libbson-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Section: libs
 Homepage: https://github.com/mongodb/libmongocrypt
 
@@ -18,7 +17,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmongocrypt0 (= ${binary:Version}), ${misc:Depends}
+Depends: libbson-dev, libmongocrypt0 (= ${binary:Version}), ${misc:Depends}
 Description: client-side field level encryption library - dev files
  libmongocrypt facilitates the client-side encryption and decryption,
  at the field level, of data stored in MongoDB.
