=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 # see ENVIRONMENT in dpkg-buildflags(1)
 # package maintainers to append CFLAGS
 #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-export DEB_CFLAGS_MAINT_APPEND  = -fPIC
+export DEB_CFLAGS_MAINT_APPEND  = -fPIC -Wno-error=deprecated-declarations
 # package maintainers to append LDFLAGS
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
@@ -25,6 +25,7 @@
 override_dh_auto_configure:
 	dh_auto_configure -B$(CURDIR)/cmake-build -- \
 	-DBUILD_VERSION=$(DEB_VERSION_UPSTREAM) \
+	-DENABLE_SHARED_BSON=ON \
 	-DCMAKE_BUILD_TYPE=RelWithDebInfo
 
 override_dh_auto_build:
